<?php 
    header('Access-Control-Allow-Origin: *');
	header('Access-Control-Allow-Methods: POST,GET,OPTIONS');
	header('Access-Control-Allow-Headers: Origin, X-Requested-With, Content-Type, Accept');
	header("Content-Type: application/json; charset=UTF-8");
	
	error_reporting(E_ALL);
    ini_set('display_errors', '1');
	
	date_default_timezone_set('Asia/Calcutta');
	
	require_once("includes/initialize.php");
	

    $data = json_decode(file_get_contents("php://input"));
    if(!empty($data->userId)){
	    $userId 		= $data->userId;
	} else if(!empty($_POST['userId'])){
	    $userId 		= $_POST['userId'];
	} else {
	    echo json_encode("Enter Employee Code");
		return false;
	}
	//$userId 		= $data->userId; 
	$userId 		= sprintf("%08d", $userId);
	
	$earlier    = new DateTime($_POST['startDate']);
    $later      = new DateTime($_POST['endDate']);

    $diff = $later->diff($earlier)->format("%a");
    
    $total_days     = $diff+1;
    
    
    if ($_POST['endDate'] < $_POST['startDate']){
        $msg[] = array('msg'=>'Invalid Date Selection','id'=> '');
        echo json_encode( $msg );
        return false;
    }
    
    
    if($_POST['leaveType'] == "Week Off" && $total_days != 1){
        $msg[] = array('msg'=>'Week Off Leave is only for 1 Day','id'=> '');
        echo json_encode( $msg );
        return false;
    }
    

    $employee = Employee::find_by_emp_code($userId);
    
    if($employee){
        
        if($_POST['leaveType'] == "Week Off"){
            
            $startDate = date('Y-m', strtotime($_POST['startDate']));

            $sql = "SELECT * FROM leave_applications where emp_code = '{$employee->emp_code}' AND startdate LIKE '%{$startDate}%' AND leave_type = 'Week Off' order by startdate DESC";
            $findWeekOff = LeaveApplications::find_by_sql($sql);
            if($findWeekOff){
                $weekOffCount = 0;
                foreach($findWeekOff as $findWeekOff){
                    $weekOffCount++;
                }
                if($weekOffCount == 5){
                    $msg[] = array('msg'=>"You can't take more then 5 Week Off",'id'=> '');
                    echo json_encode( $msg );
                    return false;
                }
            }

            $sql = "SELECT * FROM leave_applications where emp_code = '{$employee->emp_code}' AND leave_type = 'Week Off' order by startdate DESC Limit 1";
            $findWeekOff = LeaveApplications::find_by_sql($sql);
            
            if($findWeekOff){
                
                foreach($findWeekOff as $findWeekOff){
                    $last_week_off_date = $findWeekOff->startdate;
                    
                    $earlier    = new DateTime($last_week_off_date);
                    $later      = new DateTime($_POST['endDate']);
                
                    $lastWeekOffDays    = $later->diff($earlier)->format("%a");
                    $newWeekOfDate      = date('Y-m-d', strtotime($last_week_off_date. ' + 6 day'));
                    $newWeekOfDate      = date('d M Y', strtotime($newWeekOfDate));
                    
                    if ($_POST['startDate'] < $findWeekOff->startdate){
                        $msg[] = array('msg'=>"You can't take Week Off before {$newWeekOfDate}",'id'=> '');
                        echo json_encode( $msg );
                        return false;
                    }
                    
                    if($lastWeekOffDays < 6){
                        $msg[] = array('msg'=>"You can't take Week Off before {$newWeekOfDate}",'id'=> '');
                        echo json_encode( $msg );
                        return false;
                    }

                }
            }
            
        }
        

        $leave_application = new LeaveApplications();
        
        $leave_application->company_id      = $employee->company_id;
        $leave_application->emp_code        = $employee->emp_code;
        $leave_application->reason          = $_POST['reason'];
        $leave_application->startdate       = $_POST['startDate'];
        $leave_application->enddate         = $_POST['endDate'];
        $leave_application->leave_type      = $_POST['leaveType'];
        $leave_application->leave_data      = $_POST['leaveData'];
        $leave_application->total_days      = $total_days;
        $leave_application->status          = 2;
        $leave_application->_date           = date("Y-m-d");
        $leave_application->_time           = date("H:i:s");
        if($leave_application->save()){
            $msg[] = array('msg'=>'YOUR LEAVE APLICATION IS SENT TO MANAGER FOR APPROVAL','id'=> $leave_application->id);
            echo json_encode( $msg );
        } else {
            $msg[] = array('msg'=>'Fail to Submit Leave Application','id'=> '');
            echo json_encode( $msg );
        }
        
    } else {
        $msg[] = array('msg'=>'Fail to Submit Leave Application','id'=> '');
        echo json_encode( $msg );
    }
    
    


?>